//
//  ContrastiveDivergence.h
//  
//
//  Created by Roni Mittelman on 7/24/13.
//
//

#ifndef ____ContrastiveDivergence__
#define ____ContrastiveDivergence__

#include <iostream>
#include <arrayfire.h>
#include <valarray>
#endif /* defined(____ContrastiveDivergence__) */




using namespace af;
class ContrastiveDivergence{
private:
    array W, b, c, phi, mu, alpha_parm, lambda_parm;
    array h_a, h_b, v_a, v_b, Eh_a, Eh_b, Ev_b, s_a, s_b, Es_a, Es_b;
    int flag_binary_real_ssRBM; // 0- binary inputs,2- real inputs, 3-ssRBM
    int n_CD, NHidden;
    void sampleCD_binary_real(array v);
    void sampleCD_ssRBM(array v);
   
    array sigma_function(array x);
public:
    array computPH(array v);
    void sampleCD(array v);
    void sampleCDV(array v, array v0, array indices0);
    void MeanFieldV(array vt, array v0, array indices0);
    void updateParms(array W0, array b0, array c0, array phi0, array mu0, array alpha_parm0, array lambda_parm0);
    void updateParms(array W0, array b0, array c0);
    void set_flags(int flag_binary_real_ssRBM0);
    void set_NHidden(int NHidden0);
    array get_h_a();
    array get_h_b();
    array get_s_a();
    array get_s_b();
    array get_Es_a();
    array get_Es_b();
    array get_Eh_a();
    array get_Eh_b();
    array get_v_a();
    array get_v_b();
    array get_Ev_b();
    array getW();

    int get_flag_binary_real_ssRBM();
    ContrastiveDivergence(int nCD0, int NHidden0, int flag_binary_real_ssRBM0);
    ContrastiveDivergence();
    ~ContrastiveDivergence();
};

