//
//  DBN.cpp
//  
//
//  Created by Roni Mittelman on 7/24/13.
//
//

//#include "saveCodeBooks.h"

#include <fstream>
#include <iostream>
#include <valarray>
#include <vector>
#include "util.h"
#include "RTRBMrelease.h"
#include "ssRTRBMrelease.h"
#ifndef ____ContrastiveDivergence__
#include "ContrastiveDivergence.h"
#endif

int main(int argc, char** argv){
    char filename[200];
    char parameters_filename[200];
    int type;
    int n_CD;
    int num_of_nodes;
    std::valarray<int> NVisible;
    std::valarray<int> NHidden;
    int num_of_iterations;
    float learning_rate;
    float momentum;
    float l1_Theta_reg;
    int flag_learn_mask;
    int flag_causal;
    int flag_share_lambda_parm;
    float alpha_parm;
    float lambda_parm_init;
    float delta_parm, kappa;
    util::read_parms(filename, parameters_filename, &type, &n_CD, &num_of_nodes, &NVisible, &NHidden, &num_of_iterations, &learning_rate, &momentum, &l1_Theta_reg, &flag_learn_mask, &flag_causal, &flag_share_lambda_parm, &alpha_parm, &lambda_parm_init, &delta_parm, &kappa, argv);
    int NVisible0;
    std::vector<std::valarray<float> > data;
    std::valarray<int> Tvct;
    util::read_data(filename, &data, &Tvct, &NVisible0);
    if ((int)NVisible.sum()!=NVisible0){
        std::cout<<"Error: the number of observations in NVisible is different from the number of observations in the data file\n";
        return -1;
    }
    
    int flag_binary_real_ssRBM;
    if (type==0){
        flag_binary_real_ssRBM=0;
        ContrastiveDivergence CD2(n_CD, (int)NHidden.sum(), flag_binary_real_ssRBM);
        RTRBM RBHMM(&CD2, 1, learning_rate, NHidden, NVisible , momentum,l1_Theta_reg, flag_learn_mask, flag_causal, delta_parm, kappa);
        RBHMM.read_parameters(parameters_filename); // load the saved model parameters
        ///////////////////
        int vid_index=std::min(num_of_iterations,(int)data.size()-1);
        std::valarray<float> initialV(0.0,NVisible0*Tvct[vid_index]);
        for (int i=0;i<NVisible0*Tvct[vid_index];i++){
            initialV[i]=(*(data.begin()+vid_index))[i];
        }
        std::valarray<float> video(RBHMM.generate_sequence(initialV, Tvct[vid_index]));
        char filename_synthetic[]="results/synthetic_video.dat";
        util::save_matrix2file(filename_synthetic, video[std::slice(NVisible0*(Tvct[vid_index]/2),NVisible0*(Tvct[vid_index]-(Tvct[vid_index]/2)),1)], NVisible0, Tvct[vid_index]-(Tvct[vid_index]/2));
        char filename_original[]="results/original_video.dat";
        util::save_matrix2file(filename_original, (*(data.begin()+vid_index))[std::slice(NVisible0*(Tvct[vid_index]/2),NVisible0*(Tvct[vid_index]-(Tvct[vid_index]/2)),1)], NVisible0, Tvct[vid_index]-(Tvct[vid_index]/2));
    }
    return 0;
}
